#!/usr/bin/python2
"""3d-filter-blender-driver.py

This file runs blender with a script file, generating a jpeg image.

The script file is generated from opstions and string substition on a temple file.
"""

import os
import time
import sys


pid = os.getpid()
xysize = 512

xscale = 1.0
yscale = 1.0
zscale = 1.0

anti_alias_level = 1
batch = True
if len(sys.argv) > 1:
  argv = sys.argv
  i = 0
  while i < len(argv):
    a = argv[i]
    if a == '-f':
      filename = '/var/www/html/3d-filter/' + argv[i + 1]
      i += 1
    if a == '-x':
      xscale = float(argv[i + 1])
      i += 1
    if a == '-y':
      yscale = float(argv[i + 1])
      i += 1
    if a == '-z':
      zscale = float(argv[i + 1])
      i += 1
    if a == '-s':
      xysize = int(argv[i + 1])
      i += 1
    else:
      i += 1
else:
  pass


def run_command(cmd):
  print('running %s' % cmd)  # UNCOMMENT TO DEBUG COMMANDS
  os.system(cmd)

# template-3d-filter.py expect: /tmp/r-XXXXXXX.tga and /tmp/t-XXXXXXXX.tga
pyout = '/tmp/p-%d' % pid
# compose substitutions:
sed_subs = (" -e 's/XXXXXXXX/%d/'"
            " -e 's/XSCALE/%f/'"
            " -e 's/YSCALE/%f/'"
            " -e 's/ZSCALE/%f/' " % 
            (pid, xscale, yscale, zscale))
cmd = "sed %s template-3d-filter.py > %s" % (sed_subs, pyout)
run_command(cmd)

cmd = "chmod a+x %s" % pyout
run_command(cmd)


if True:
  start = time.time()
  # remove old texture and heightfield images
  ###cmd = '/bin/rm -f /tmp/t-%d.tga /tmp/r-%d.tga' % (pid, pid)
  run_command(cmd)
  cmd = 'echo %s >> /tmp/foofoo' % filename
  run_command(cmd)
  cmd = 'echo %d >> /tmp/foofoo' % pid
  run_command(cmd)
  cmd = 'anytopnm %s | pamtotga >  /tmp/t-%d.tga' % (filename, pid)
  run_command(cmd)
  cmd = 'anytopnm %s | ppmtopgm > /tmp/totally-tmp-%d.pgm' % (filename, pid)
  run_command(cmd)
  # create heightfield image 
  cmd = 'cat /tmp/totally-tmp-%d.pgm | pamscale -filter cubic -xysize %d %d' % (pid, xysize, xysize)
  #cmd += '|  pnmsmooth -width 3 -height 3'
  #cmd += '|  pnmsmooth -width 3 -height 3'
  cmd +=  '|  pamtotga > /tmp/r-%d.tga' % pid
  run_command(cmd)
  # create texture
  output_filename = filename + 'XX'
  if not os.path.isfile(output_filename):
    cmd = 'blender blank1.blend -o %s -P %s -b -f 1' % (
        output_filename, pyout)
  else:
    cmd = '/bin/true'
  run_command(cmd)
  #print 'Time to Execute: %3.2f seconds' % (start - time.time())
#Clean up
cmd = '/bin/rm -f /tmp/r-%d.tga /tmp/p-%d /tmp/t-%d.tga /tmp/t-%d.pgm /tmp/totally-tmp-%d.pgm %s' % (
     pid, pid, pid, pid, pid, pyout)
run_command(cmd)
