#!/usr/bin/python

# (C) 2008 Sean Brennan <sean@zettix.com>

""" This is the main cgi binary.  It accepts the following variables:
Image: image like jpg/gif
zscale: float
yscale: float
zscale: float

It returns the blender image and a simple web page.
"""

import sys
import os
import re
import cgi
import math
import time
#import Image
#mport ImageDraw
import glob


form = cgi.FieldStorage() # instantiate only once!

upload_image = form.getfirst('Image', '')
xscale_str = form.getfirst('Xscale', '')
yscale_str = form.getfirst('Yscale', '')
zscale_str = form.getfirst('Zscale', '')
gridsize_str = form.getfirst('Gridsize', '')

xscale = float(xscale_str)
yscale = float(yscale_str)
zscale = float(zscale_str)
gridsize = int(gridsize_str)

if xscale == 0.0:
  xscale = 1.0
if yscale_str == 0.0:
  yscale = 1.0
if gridsize == 0:
  gridsize = 100

class ParseError(Exception):
  pass

def pdict(f):
  if type(f) == type({}):
    for x in f:
      print "%s : %s <br>" % (x, f[x])
  else:
    print "%s - [%s] <br>" % (f, str(type(f)))

class BlenderWeb(object):
  def __init__(self):
    self.error = ''
    self.image = None
    self.filename = ''

  def RunBlender(self):
    # for testing:
    #os.system('./super-duper.py -re %f -im %f -radius %f ' %
    item = form['Image']
    if item.file:
      data = item.file.read()
    else:
      print "NOOOOOOOOOOOOOOO   File found <br>"
      data = "No file"
    self.filename = item.filename
    for badchar in (' ', '\\', '/', '\'', '"', '&', '|'):
      self.filename = self.filename.replace(badchar, '_')
    outfile = open('/var/www/html/3d-filter/%s' % self.filename, 'w')
    outfile.write(data)
    outfile.close()
    command_flags = '-f %s -x %f -y %f -z %f -s %d' % (self.filename, xscale, yscale, zscale, gridsize)
    os.system('./3d-filter-blender-driver.py %s >& /tmp/3d-filter-blender.log' % command_flags)
    # update recent

  def EmitImage(self):
    item = form['Image']
    filename = self.filename
    print "Filename: %s<br>" % filename
    print "<img src='/3d-filter/%sXX0001.jpg'>" % filename
    print "<img src='/3d-filter/%s'>" % filename
    print "<br>Recent submission:<br>"
    #print "<img src='/3d-filter/recent.jpg'>"
    recent_out = os.popen("ls -tr /var/www/html/3d-filter/*XX0001.jpg | tail -2 | head -1").readlines()[0].strip()
    recent_jpg = '/var/www/html/3d-filter/recent.jpg'
    if os.path.islink(recent_jpg):
      os.unlink(recent_jpg)
    os.symlink(recent_out, recent_jpg)
    #print "linked %s to %s " % (recent_out, recent_jpg) # DEbUGGING


  def EmitHtml(self):
    print "Content-Type: text/html"
    print
    print """\
<html>
<title>3D For Free!</title>
<body style="color: rgb(192, 192, 192); background-color: rgb(0, 0, 0);"
 alink="#99ff99" link="#33cc00" vlink="#009900">

"""
    self.RunBlender()
    self.EmitImage()
    print "<br><a href=/3d-filter>Go Back</a><br>"
    print """</body></html>"""

  def Run(self):
    self.EmitHtml()
    pass


if __name__ == '__main__':
  frak = BlenderWeb()
  frak.image = upload_image;
  frak.Run()
